//DESCRIPTION:Select the body cells in the column containing the cursor

// Modified 2023-01-09
// Keith Gilbert, Gilbert Consulting
// www.gilbertconsulting.com

Pre();

function Pre () {  
	// Check to make sure all required conditions are met
	if (!app.documents.length) { 
		alert("No InDesign documents are open. Please open a document and try again.");
		return;
	}  
	if (app.selection.length == 1) { // If the selection contains more than one item, the selection is not text selected with the Type tool
		switch(app.selection[0].constructor.name) {
			case "InsertionPoint":
			case "Character":
			case "Word":
			case "TextStyleRange":
			case "Line":
			case "Paragraph":
			case "TextColumn":
			case "Text":
				Main(app.selection[0].parent);
				break;
			case "Cell":
				Main(app.selection[0]);
				break;
			case "Table":
			case "Rectangle":
			case "Oval":
			case "Polygon":
			case "GraphicLine":
			case "Image":
			case "PDF":
			case "EPS":
			default:
				alert("Please choose an insertion point in a table cell and try again.");
				return;
				break;
		}
	}
	else{
		alert("Please choose an insertion point in a table cell and try again.");
		return;
	}
}  
function Main(myCell) {
	var _scriptRedraw = app.scriptPreferences.enableRedraw;
	app.scriptPreferences.enableRedraw = false;  
	myCell.select();
	var myColumn  = myCell.parentColumn;
	for (var i=0; i<myColumn.cells.length; i++) {
		if ((myColumn.cells[i].rowType == RowTypes.BODY_ROW) && (myColumn.cells[i].columnSpan == 1)) {
			myColumn.cells[i].select(SelectionOptions.ADD_TO);
		}
	}
	app.scriptPreferences.enableRedraw = _scriptRedraw;  
}
